//+------------------------------------------------------------------+
//|                                                 Hi_Lo_240min.mq4 |
//|                                              kris.pivo@gmail.com |
//|          indicator based on IgorAD framework for hourly + pivots |
//+------------------------------------------------------------------+
#property indicator_chart_window
#property indicator_buffers 8
#property indicator_color1 Silver
#property indicator_color2 Silver
#property indicator_color3 DarkSlateGray
#property indicator_color4 DarkSlateGray
#property indicator_color5 DarkSlateGray
#property indicator_color6 DarkSlateGray
#property indicator_color7 DarkSlateGray
#property indicator_color8 DarkSlateGray
//---- input parameters
extern int Time_Frame      = 240;
extern int Target_Profit   = 25;
extern int Bars_Limit      = 250;   // draw levels [250] bars back
extern int lm              = 0;
//---- buffers
double R3Buffer[];
double R2Buffer[];
double R1Buffer[];
double HiBuffer[];
double LoBuffer[];
double S1Buffer[];
double S2Buffer[];
double S3Buffer[];


//-------
int Displacement;

//-------
int init()
  {
//------- indicators
   IndicatorBuffers(8);
   
   SetIndexStyle(0,DRAW_LINE,STYLE_SOLID,1);
   SetIndexStyle(1,DRAW_LINE,STYLE_SOLID,1);
   SetIndexStyle(2,DRAW_LINE,STYLE_DOT);
   SetIndexStyle(3,DRAW_LINE,STYLE_DOT); 
   SetIndexStyle(4,DRAW_LINE,STYLE_DOT);
   SetIndexStyle(5,DRAW_LINE,STYLE_DOT); 
   SetIndexStyle(6,DRAW_LINE,STYLE_DOT);
   SetIndexStyle(7,DRAW_LINE,STYLE_DOT);       
   
   SetIndexBuffer(0,HiBuffer);
   SetIndexBuffer(1,LoBuffer);
   SetIndexBuffer(2,R1Buffer);   
   SetIndexBuffer(3,R2Buffer);
   SetIndexBuffer(4,R3Buffer);   
   SetIndexBuffer(5,S1Buffer);
   SetIndexBuffer(6,S2Buffer);   
   SetIndexBuffer(7,S3Buffer);
      
   if( lm==0)
      Displacement=Time_Frame/Period();
   else
      Displacement=1;

      SetIndexShift(0,Displacement);
      SetIndexShift(1,Displacement);
      SetIndexShift(2,Displacement);
      SetIndexShift(3,Displacement);
      SetIndexShift(4,Displacement);
      SetIndexShift(5,Displacement);
      SetIndexShift(6,Displacement);
      SetIndexShift(7,Displacement);
//-------
   return(0);
  }
//-------
int start()
  {
   int cb,sbb_index,i;
   int counted_bars=IndicatorCounted();
   datetime Corresp_bbbnTime;
   double StHigh,StLow;
 
   for(cb=Bars_Limit;cb>=0;cb--)
   {
      Corresp_bbbnTime=NormTimeBarBegin(Time[cb],Time_Frame);
      sbb_index=n_iBarShift(Corresp_bbbnTime,Period());
      
      StHigh=High[iHighest(NULL,0,MODE_HIGH,sbb_index-cb+1,cb)];
      StLow=Low[iLowest(NULL,0,MODE_LOW,sbb_index-cb+1,cb)];
      
      if( cb<sbb_index )
      {
         for(i=cb+1;i<=sbb_index;i++)
         {
            HiBuffer[i]=StHigh;
            LoBuffer[i]=StLow;
            R1Buffer[i]=HiBuffer[i]+Target_Profit*Point*1;
            R2Buffer[i]=HiBuffer[i]+Target_Profit*Point*2;
            R3Buffer[i]=HiBuffer[i]+Target_Profit*Point*3;
            S1Buffer[i]=LoBuffer[i]-Target_Profit*Point*1;
            S2Buffer[i]=LoBuffer[i]-Target_Profit*Point*2;
            S3Buffer[i]=LoBuffer[i]-Target_Profit*Point*3;
         }
      }
   }
//-----------------
   return(0);
  }
//-----------------
datetime NormTimeBarBegin(datetime intime, int TF)
  {
   datetime outtime;
   if(TF!=10080)
   {
      outtime=MathFloor(intime/TF/60)*TF*60;
   }
   else
   {
      outtime=MathFloor((intime+345600)/TF/60)*TF*60-345600;
   }
   return(outtime);
  }
//-----------------
int n_iBarShift(datetime intime, int TF)
  {
   int bindex,b_count;
   datetime TArray[];
   b_count=ArrayCopySeries(TArray,MODE_TIME,Symbol(),TF);
   bindex=ArrayBsearch(TArray,NormTimeBarBegin(intime,TF),0,0,MODE_ASCEND) ;
   return(bindex);
  }
//-----------------  

